/* $Id: s502.h,v 1.7 1995/07/18 12:18:16 jfree Exp jfree $
 */
#ifndef _S502_H_
#define _S502_H_

#include "fr.h"

#define S502_VERSION	"0.20"
#define PACKED          __attribute__((packed))

#define MAX_DATA		0x1000
#define CTL_BLK_OFFSET		0x0F60

#define INFORMATION_WRITE			0x01
#define INFORMATION_READ			0x02
#define ISSUE_IN_CHANNEL_SIGNALLING_FRAME	0x03
#define SET_DLCI_CONFIGURATION			0x10
#define READ_DLCI_CONFIGURATION			0x11
#define DISABLE_COMMUNICATIONS			0x12
#define ENABLE_COMMUNICATIONS			0x13
#define READ_DLC_STATUS				0x14
#define READ_DLC_STATISTICS			0x15
#define FLUSH_DLC_STATISTICS			0x16
#define LIST_ACTIVE_DLCIs			0x17
#define FLUSH_INFORMATION_BUFFERS		0x18
#define ADD_DLCIs				0x20
#define DELETE_DLCIs				0x21
#define ACTIVATE_DLCs				0x22
#define DEACTIVATE_DLCs				0x23
#define READ_MODEM_STATUS			0x30
#define SET_MODEM_STATUS			0x31
#define READ_COMMS_ERR_STATS			0x32
#define FLUSH_COMMS_ERR_STATS			0x33
#define READ_CODE_VERSION			0x40

#define OP_SUCCESS		0x00
#define NOT_ENABLED		0x01
#define CHANNEL_INOPERATIVE	0x02
#define NO_FRAMES_QUEUED	0x05

#define DLCI_NOT_CONFIG		0x01

#define DLCI_INACTIVE		0x03
#define DLCI_INVALID		0x04
#define MAX_LEN_EXCEEDED	0x05
#define TC_LEN_OVERFLOW		0x06
#define CIR_OVERFLOW		0x07
#define NO_TX_BUFS		0x08

#define MODEM_FAILURE	0x10
#define CHANNEL_DOWNED	0x11
#define CHANNEL_UPPED	0x12
#define DLCI_CHANGE	0x13
#define DLCI_CONFIG_ERR	0x14
#define INVALID_COMMAND	0x1F

typedef struct {
	u_char	invisible[CTL_BLK_OFFSET];
	u_char	opPending;
	u_char	cmd;
	u_short	bufLen;
	u_char	retCode;
	u_short	dlci PACKED;
	u_char	bits PACKED;
	u_short	appRxDrop PACKED;
	u_long	intRxDrop PACKED;
	u_short	unused PACKED;
	u_char	data[MAX_DATA] PACKED;
	u_char	scratch[0x0080] PACKED;
	u_char	bogus PACKED;
	u_char	txSpaceAvail PACKED;
	u_char	rxFramesAvail PACKED;
	u_char	modemStatus PACKED;
	u_char	cruft[0x000C];
} fr_shm_t;

typedef struct fr {
	u_char	cmdPending;
	int	txQueued;
	fr_shm_t	*shm;
	fr_stats_t	stats;
	struct fr	*next;
	struct device	*dev;
	struct sk_buff_head	*skq;
	struct timer_list	timer;
} fr_t;

typedef struct {
	short	stationCfg;
	short	cfgBits;
	short	baud;
	short	clkSrc;
	short	maxLenIFrame;
	short	T391;
	short	T392;
	short	N391;
	short	N392;
	short	N393;
	short	CIRfwd;
	short	BcFwd;
	short	BeFwd;
	short	CIRbwd;
	short	BcBwd;
	short	BeBwd;
	short	dlciList;
} dlciCfg_t;

#endif /* ndef _S502_H_ */
